function [Z,WC, WCinit ,errGD,iterGD]=GDOpt(x0,model,c,nbsim,nbGrad)

n=max(x0);
nx=n(1); ny=n(2); nz=n(3);

load 'modelInit.mat' 'fluid' 'G' 'idxActiveCells' 'rock' 'sol' 'W' 'WCref' 'Widx' 


for j=1:nbsim
    rng('default')
    rng(j+54154);
    ysim=fftma(model,c,25+(j-1),1,nx,1,ny,1,nz,1);
    err=nan(nbGrad,1);
    ynew= fftma(model,c,1542+(j-1)*nbGrad,nbGrad,nx,1,ny,1,nz,1);
    errNow=1000;

    % Ici on calcul les courbes de niveau d'eau initiale
    ysim=fftma(model,c,25+(j-1),1,nx,1,ny,1,nz,1);
    [~, WCinit(:,:,j)] = MSRT_WC(ysim,WCref,Widx,G,fluid,W,rock,sol,idxActiveCells);

    for i=1:nbGrad
        
        %7- Calculation of Z(x); repeat nl time
        options=optimset('MaxIter',10,'TolX',10^-8,'Display','off');
        func = @(t) MSRThydraulicHeadGD(ysim,t,ynew(:,i),WCref,Widx,G,fluid,W,rock,sol,idxActiveCells);
        X=rand();
        X=[X-0.5 X+0.5]*2*pi;
        [t,ERR] = fminbnd(func, X(1),X(2),options);
        if ERR<errNow
            ysim=ysim*cos(t)+ynew(:,i)*sin(t);
            err(i)=ERR;
            errNow=ERR;
        else
            err(i)=errNow;
        end
        [j i err(i)]
        
    end
    [~, WCsim] = MSRT_WC(ysim,WCref,Widx,G,fluid,W,rock,sol,idxActiveCells);

    Z(:,j)=ysim;
    iterGD(j)=i;
    errGD(:,j)=err;
    WC(:,:,j) = WCsim;
end

function err=MSRThydraulicHeadGD(ysim,t,ynew,WCref,Widx,G,fluid,W,rock,sol,idxActiveCells)

ysim=ysim*cos(t)+ynew*sin(t);
err=MSRT_WC(ysim,WCref,Widx,G,fluid,W,rock,sol,idxActiveCells);