function [err, WCsim] = MSRT_WC(zsim,WCref,Widx,G,fluid,W,rock,initSol,idxActiveCells)

gravity on                                     

% Perméabilité anisotrope de la conductivité hydraulique (Tenseur K)
rock.perm = [10.^(zsim(idxActiveCells) - 13), ...   % Kxx
             10.^(zsim(idxActiveCells) - 13), ...   % Kyy
             10.^(zsim(idxActiveCells) - 13) / 10]; % Kzz

T = computeTrans(G, rock); % Transmissibilité
psolve = @(state) incompTPFA(state, G, T, fluid, 'wells', W);                   % Solveur pression
tsolve = @(state, dT) implicitTransport(state, G, dT, rock, fluid, 'wells', W); % Solveur transport
sol= psolve(initSol);

%% Simulation du Transport entre les Puits
num_steps = 10;
time_steps = logspace(0, 3, num_steps) * day;  % Pas de temps logarithmique
solutions = cell(num_steps, 1);
WCsim = zeros(num_steps, 3); 
for i = 1:num_steps
    sol = tsolve(sol, time_steps(i));
    sol = psolve(sol);
    solutions{i} = sol;
    WCsim(i, :) = sol.s(Widx);
end

err=sqrt(mean( (WCsim-WCref).^2 ,'all'));